#! /bin/bash
# -*- mode: Bash; tab-width: 2; indent-tabs-mode: nil; coding: utf-8 -*-
# vim:shiftwidth=4:softtabstop=4:tabstop=4:
# XPDX-License-Identifier: GPL-2.0+"

set -x
set -e

project="pinball"x
sudo=
cd /etc/pinball

. pinball.env.sh

set

${sudo} chmod u+rx *.sh

${sudo} install -d /etc/default
${sudo} install  pinball /etc/default/pinball

${sudo} systemctl get-default | grep 'graphical.target'

${sudo} journalctl --rotate \
    && ${sudo} journalctl --vacuum-time=1s
		  
${sudo} systemctl stop pinball ||:
${sudo} systemctl stop weston ||:
${sudo} systemctl stop xinit ||:

${sudo} systemctl disable pinball ||:
${sudo} systemctl disable weston ||:
${sudo} systemctl disable xinit ||:


if [ "${PINBALL_DISPLAY_MANAGER}" = "weston" ] ; then
    ${sudo} install -d /etc/xdg/${PINBALL_DISPLAY_MANAGER}
    ${sudo} install weston.ini /etc/xdg/${PINBALL_DISPLAY_MANAGER}

    ${sudo} systemctl enable ${PWD}/${PINBALL_DISPLAY_MANAGER}.service
    ${sudo} systemctl enable ${PWD}/pinball.service
    ${sudo} systemctl restart pinball
fi

${sudo} systemctl daemon-reload ||:
# TODO install from /lib/systemd/system/ on debian
${sudo} systemctl enable ${PWD}/${PINBALL_DISPLAY_MANAGER}.service
${sudo} systemctl restart ${PINBALL_DISPLAY_MANAGER}

cat<<EOF
${sudo} journalctl -u ${PINBALL_DISPLAY_MANAGER} | tail
${sudo} journalctl -u ${PINBALL_DISPLAY_MANAGER} -f | less
$sudo systemd-analyze --user critical-chain
EOF

echo "# Setup terminated, reboot now"
